# Budowa środowiska

W tym rozdziale przedstawię, jak na przygotowanej już platformie (NixOS, Ubuntu, etc.) zbudować środowisko, w którym będziemy budować usługi w chmurze hscloud.

Opis opiera się na informacjach uzyskanych z rozmów z @inf oraz z [dokumentacji użytkownika hscloud](https://code.hackerspace.pl/hswaw/hscloud/src/branch/master/cluster/doc/user.md).

## Kroki

Ze względu na drobny błąd, należy pozbyć się z `shell.nix` komendy kompilacji `clang`:

```bash
sed -i '/gcc binutils clang/s/clang//g' "shell.nix"
```

Tworzymy środowisko, w którym będziemy budować usługi. W tym celu tworzymy środowisko na podstawie definicji w pliku `shell.nix`:

```bash
nix-shell
```

Używamy teraz narzędzia `bazel`, aby zbudować i uruchomić potrzebne usługi, m.in. `prodaccess` oraz `kubectl`:

```bash
bazel build //tools:install
bazel run //tools:install
```

Teraz możemy poprosić o przyznanie nam dostępu do klastra hscloud poprzez narzędzie [prodaccess](https://pkg.go.dev/code.hackerspace.pl/hscloud/cluster/prodaccess#section-readme). w miejsce `$hs_username` należy wstawić nazwę użytkownika w SSO hackerspejsu:

```bash
prodaccess -username $hs_username
```

W przypadku braku dostępu do klastra, należy skontaktować się w ramach [Matrix](https://matrix.hackerspace.pl/) z [@q3k](q3k:hackerspace.pl) bądź z [@inf](informatic:hackerspace.pl).

Aby sprawdzić, czy mamy dostęp do klastra, możemy wykonać polecenie:

```bash
# pokazuje wersję Kubernetesów
kubectl version

# pokazuje statystyki klastra
kubectl top nodes
```

Możemy również wywołać publiczny obraz Dockera (ponownie, w miejsce `$hs_username` należy wstawić nazwę użytkownika w SSO hackerspejsu):

```bash
# aby utworzyć instancję (pod) alpine
kubectl -n personal-$hs_username run --image=alpine:latest -it foo

# aby skasować instancję (pod) alpine
kubectl -n personal-$hs_username delete pod foo
```

## Następny krok

Następny krok: [Tworzenie usługi http](03-create-service.md)